<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--左侧部门数据-->
      <el-col :span="6" :xs="24">
        <div class="head-container">
          <el-input
            v-model="deptName"
            placeholder="请输入计量设备名称"
            clearable
            size="small"
            prefix-icon="el-icon-search"
            style="margin-bottom: 20px"
          />
        </div>
        <div class="head-container tree">
          <el-tree
            :data="deptOptions"
            :props="defaultProps"
            :expand-on-click-node="false"
            :filter-node-method="filterNode"
            ref="tree"
            node-key="id"
            default-expand-all
            highlight-current
            @node-click="handleNodeClick"
          />
        </div>
      </el-col>
      <!--右侧用户数据-->
      <el-col :span="18" :xs="24">
        <!--头部搜索条件输入框  -->
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="采集时间">
            <el-date-picker
              v-model="dateRangeone"
              style="width: 240px"
              type="datetime"
              placeholder="选择日期时间"
              value-format="yyyy-MM-dd HH:mm:ss"
              @change="datetimechange"
            ></el-date-picker>


          </el-form-item>
          <el-form-item><div>-</div></el-form-item>
          <el-form-item><el-date-picker
              v-model="dateRangetwo"
              style="width: 240px"
              type="datetime"
              placeholder="选择日期时间"
              value-format="yyyy-MM-dd HH:mm:ss"
              @change="datetimechangetwo"
            ></el-date-picker></el-form-item>
          <el-form-item label="时间范围" prop="status">
            <el-select
              v-model="queryParams.type"
              placeholder="请选择"
              clearable
              style="width: 240px"
              @change="selectchange"
            >
              <el-option
                v-for="dict in dict"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
        </el-form>
        <!--柱状图  -->
        <el-card style="height: 750px;margin-bottom: 20px">
          <!-- <div slot="header"><span style="font-size: 14px;">能耗统计</span></div> -->
          <div style="width: 100%;height: 740px;" id="card"></div>
        </el-card>
      </el-col>
    </el-row>


  </div>
</template>

<script>
import { dnbCountingData, deptTreeSelect } from "@/api/ems/base/tongBianalyse";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import * as echarts from 'echarts';

export default {
  name: "User",
  dicts: ['sys_normal_disable', 'sys_user_sex'],
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      userList: null,
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      // 是否显示弹出层
      open: false,
      // 部门名称
      deptName: undefined,
      // 默认密码
      initPassword: undefined,
      // 日期范围
      dateRange: [],
      dateRangeone:'',
      dateRangetwo:'',
      // 岗位选项
      postOptions: [],
      // 角色选项
      roleOptions: [],
      // 表单参数
      form: {},
      defaultProps: {
        children: "children",
        label: "lable"
      },
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/system/user/importData"
      },
      // 查询参数
      queryParams: {
        type: 'hour',
        startTime: undefined,
        endTime: undefined,
        energyType: 2,
        monitorIds: undefined,
      },
      // 列信息
      columns: [
        { key: 0, label: `计量设备编号`, visible: true },
        { key: 1, label: `计量设备名称`, visible: true },
        { key: 2, label: `采集时间`, visible: true },
        { key: 3, label: `功率因数`, visible: true },
        { key: 4, label: `仪表值(kW·h)`, visible: true },
        { key: 5, label: `采集方式`, visible: true },
      ],
      // 表单校验
      rules: {
        userName: [
          { required: true, message: "用户名称不能为空", trigger: "blur" },
          { min: 2, max: 20, message: '用户名称长度必须介于 2 和 20 之间', trigger: 'blur' }
        ],
        nickName: [
          { required: true, message: "用户昵称不能为空", trigger: "blur" }
        ],
        password: [
          { required: true, message: "用户密码不能为空", trigger: "blur" },
          { min: 5, max: 20, message: '用户密码长度必须介于 5 和 20 之间', trigger: 'blur' }
        ],
        email: [
          {
            type: "email",
            message: "请输入正确的邮箱地址",
            trigger: ["blur", "change"]
          }
        ],
        phonenumber: [
          {
            pattern: /^1[3|4|5|6|7|8|9][0-9]\d{8}$/,
            message: "请输入正确的手机号码",
            trigger: "blur"
          }
        ]
      },
       //采集方式
   dict:[
        {label:'时',value:'hour'},
        {label:'日',value:'day'},
        {label:'月',value:'month'},
        {label:'年',value:'year'}
      ],
       //柱状图+折线图
       option: {
        title: {
          text: "年同比分析",
          left: "center",
        },
        tooltip: {
          trigger: "axis",
          formatter:function(params){
          return params[0].name + '<br>' +
          params[0].marker + ' ' +params[0].seriesName+"(kW·h):"+params[0].data+'<br>' +
          params[1].marker + ' ' +params[1].seriesName+"(kW·h):"+params[1].data;
          },
          axisPointer: {
            type: "cross",
            crossStyle: {
              color: "#999",
            },
          },
        },
        // toolbox: {
        //   feature: {
        //     dataView: { show: true, readOnly: false },
        //     magicType: { show: true, type: ["line", "bar"] },
        //     restore: { show: true },
        //     saveAsImage: { show: true },
        //   },
        // },
        legend: {
          data: ["今年", "去年"],
          right: "5%",
        },
        xAxis: [
          {
            type: "category",
            data: [],
            axisPointer: {
              type: "shadow",
            },
          },
        ],
        yAxis: [
          {
            type: "value",
            name: "单位:KW-h",
            axisLine: {
      show: true,
    }
          },
        ],
        series: [
          {
            name: "今年",
            type: "bar",
            tooltip: {
              valueFormatter: function (value) {
                return value;
              },
            },
            data: [

            ],
          },
          {
            name: "去年",
            type: "bar",
            tooltip: {
              valueFormatter: function (value) {
                return value;
              },
            },
            data: [

            ],
          }
        ],
      },
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    this.dateRangeone=new Date(new Date().setHours(0, 0, 0, 0));
    var d = new Date(this.dateRangeone);
    let m = ('0'+(d.getMonth()+1)).slice(-2);;
    let tian = ('0'+d.getDate()).slice(-2);
    let h = ('0'+d.getHours()).slice(-2);
    let M = ('0'+d.getMinutes()).slice(-2);
    let s = ('0'+d.getSeconds()).slice(-2);

    console.log('d',d)
    this.dateRangeone = d.getFullYear()+ '-'+m+ '-'+tian+ ' '+ h+ ':'+M+':'+s;
    //console.log('zhuanhuahou',this.dateRangeone)
    this.dateRangetwo=new Date(new Date().setHours(0, 0, 0, 0) + 24 * 60 * 60 * 1000 - 1);
    var d1 = new Date(this.dateRangetwo);
    let m1 = ('0'+(d1.getMonth()+1)).slice(-2);
    let tian1 = ('0'+d1.getDate()).slice(-2);
    let h1 = ('0'+d1.getHours()).slice(-2);
    let M1 = ('0'+d1.getMinutes()).slice(-2);
    let s1 = ('0'+d1.getSeconds()).slice(-2);
    console.log('tian1.length',tian1)
    this.dateRangetwo = d1.getFullYear()+ '-'+m1+ '-'+tian1+ ' '+ h1+ ':'+M1+':'+s1;
    this.getDeptTree();
  },
  mounted() {
          var chartDom = document.getElementById('card');
          var myChart = echarts.init(chartDom);
          this.option && myChart.setOption(this.option);
  },
  methods: {
    /** 查询用户列表 */
     //数组转树形结构
     tranListToTreeData(list) {
  // 最终要产出的树状数据的数组
  const treeList = []
  // 所有项都使用对象存储起来
  const map = {}

  // 建立一个映射关系：通过id快速找到对应的元素
  list.forEach(item => {
    if (!item.children) {
      item.children = []
    }
    map[item.id] = item
  })

  list.forEach(item => {
    // 对于每一个元素来说，先找它的上级
    //    如果能找到，说明它有上级，则要把它添加到上级的children中去
    //    如果找不到，说明它没有上级，直接添加到 treeList
    const parent = map[item.pId]
    // 如果存在则表示item不是最顶层的数据
    if (parent) {
      parent.children.push(item)
    } else {
      // 如果不存在 则是顶层数据
      treeList.push(item)
    }
  })
  // 返回出去
  return treeList
},
    /** 查询部门下拉树结构 */
    getDeptTree() {
      deptTreeSelect().then(response => {
         response.map((item,index)=>{
          item,
          item.oid=item.id,
          item.lable = item.name
        })
        this.deptOptions = this.tranListToTreeData(response);
        console.log(this.deptOptions)

        //this.deptOptions = response.data;
      });
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.lable.indexOf(value) !== -1;
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.monitorId = data.monitorId;
      this.handleQuery();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        userId: undefined,
        deptId: undefined,
        userName: undefined,
        nickName: undefined,
        password: undefined,
        phonenumber: undefined,
        email: undefined,
        sex: undefined,
        status: "0",
        remark: undefined,
        postIds: [],
        roleIds: []
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      //this.queryParams.pageNum = 1;
      this.dnbCountingData();
    },
    datetimechange(){
      this.handleQuery();
    },
    datetimechangetwo(){
      this.handleQuery();
    },
    selectchange(){
      this.handleQuery();
    },
     //****柱状图请求 */
     dnbCountingData(){
      this.loading = true;
        dnbCountingData({
        type:this.queryParams.type,
        startTime: this.dateRangeone,
        endTime: this.dateRangetwo,
        monitorId: this.queryParams.monitorId,
        energyType: 2
      }).then(response => {
            this.option.xAxis[0].data = response.data.timeList;
            this.option.series[0].data = response.data.今年;
            this.option.series[1].data = response.data.去年;
            var chartDom = document.getElementById('card');
          var myChart = echarts.init(chartDom);
          this.option && myChart.setOption(this.option);
            // this.total = response.total;
          // this.loading = false;

//           var option;
//           option = {
//     xAxis: {
//     type: 'category',
//     data: ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
//     },
//     yAxis: {
//     type: 'value'
//   },
//   series: [
//     {
//       data: [120, 200, 150, 80, 70, 110, 130],
//       type: 'bar'
//     }
//   ]
// };
//  this.option = option;

        }
      );

    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.queryParams.deptId = undefined;
      this.$refs.tree.setCurrentKey(null);
      this.handleQuery();
    },
  }
};
</script>
<style lang="scss" scoped>
.tree {
   width:220px;
 ::v-deep .el-tree-node {
    white-space: normal;//关键代码!!!!!!!!!
    .el-tree-node__content {
      height: 100%;
      align-items: start;
    }
  }
}
</style>
